3 # Copyright (c) 2005, 2006 Junio C Hamano
5 USAGE='[--signoff] [--dotest=<dir>] [--utf8] [--binary] [--3way] <mbox>
6 or, when resuming [--skip | --resolved]'
9 git var GIT_COMMITTER_IDENT >/dev/null || exit
12 echo "$1" >"$dotest/next"
17 rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
18 "$dotest/patch" "$dotest/info"
19 echo "$next" >"$dotest/next"
24 O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
26 rm -fr "$dotest"/patch-merge-*
27 mkdir "$dotest/patch-merge-tmp-dir"
29 # First see if the patch records the index info that we can use.
30 if git-apply -z --index-info "$dotest/patch" \
31 >"$dotest/patch-merge-index-info" 2>/dev/null &&
32 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
33 git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
34 GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
35 git-write-tree >"$dotest/patch-merge-base+" &&
36 # index has the base tree now.
38 cd "$dotest/patch-merge-tmp-dir" &&
39 GIT_INDEX_FILE="../patch-merge-tmp-index" \
40 GIT_OBJECT_DIRECTORY="$O_OBJECT" \
41 git-apply $binary --index <../patch
44 echo Using index info to reconstruct a base tree...
45 mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
46 mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
48 # Otherwise, try nearby trees that can be used to apply the
53 # Hoping the patch is against our recent commits...
54 git-rev-list --max-count=$N HEAD
56 # or hoping the patch is against known tags...
57 git-ls-remote --tags .
61 # See if we have it as a tree...
62 git-cat-file tree "$base" >/dev/null 2>&1 || continue
64 rm -fr "$dotest"/patch-merge-* &&
65 mkdir "$dotest/patch-merge-tmp-dir" || break
67 cd "$dotest/patch-merge-tmp-dir" &&
68 GIT_INDEX_FILE=../patch-merge-tmp-index &&
69 GIT_OBJECT_DIRECTORY="$O_OBJECT" &&
70 export GIT_INDEX_FILE GIT_OBJECT_DIRECTORY &&
71 git-read-tree "$base" &&
72 git-apply $binary --index &&
73 mv ../patch-merge-tmp-index ../patch-merge-index &&
74 echo "$base" >../patch-merge-base
75 ) <"$dotest/patch" 2>/dev/null && break
79 test -f "$dotest/patch-merge-index" &&
80 his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
81 orig_tree=$(cat "$dotest/patch-merge-base") &&
82 rm -fr "$dotest"/patch-merge-* || exit 1
84 echo Falling back to patching base and 3-way merge...
86 # This is not so wrong. Depending on which base we picked,
87 # orig_tree may be wildly different from ours, but his_tree
88 # has the same set of wildly different changes in parts the
89 # patch did not touch, so resolve ends up cancelling them,
90 # saying that we reverted all those changes.
92 git-merge-resolve $orig_tree -- HEAD $his_tree || {
93 if test -d "$GIT_DIR/rr-cache"
97 echo Failed to merge in the changes.
103 dotest=.dotest sign= utf8= keep= skip= interactive= resolved= binary=
105 while case "$#" in 0) break;; esac
108 -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
109 dotest=`expr "$1" : '-[^=]*=\(.*\)'`; shift ;;
110 -d|--d|--do|--dot|--dote|--dotes|--dotest)
111 case "$#" in 1) usage ;; esac; shift
114 -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
115 --interacti|--interactiv|--interactive)
116 interactive=t; shift ;;
118 -b|--b|--bi|--bin|--bina|--binar|--binary)
121 -3|--3|--3w|--3wa|--3way)
123 -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
125 -u|--u|--ut|--utf|--utf8)
127 -k|--k|--ke|--kee|--keep)
130 -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
145 # If the dotest directory exists, but we have finished applying all the
146 # patches in them, clear it out.
147 if test -d "$dotest" &&
148 last=$(cat "$dotest/last") &&
149 next=$(cat "$dotest/next") &&
151 test "$next" -gt "$last"
158 test ",$#," = ",0," ||
159 die "previous dotest directory $dotest still exists but mbox given."
162 # Make sure we are not given --skip nor --resolved
163 test ",$skip,$resolved," = ,,, ||
164 die "we are not resuming."
167 mkdir -p "$dotest" || exit
169 git-mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" || {
174 # -b, -s, -u and -k flags are kept for the resuming session after
176 # -3 and -i can and must be given when resuming.
177 echo "$binary" >"$dotest/binary"
178 echo "$sign" >"$dotest/sign"
179 echo "$utf8" >"$dotest/utf8"
180 echo "$keep" >"$dotest/keep"
181 echo 1 >"$dotest/next"
186 files=$(git-diff-index --cached --name-only HEAD) || exit
187 if [ "$files" ]; then
188 echo "Dirty index: cannot apply patches (dirty: $files)" >&2
193 if test "$(cat "$dotest/binary")" = t
195 binary=--allow-binary-replacement
197 if test "$(cat "$dotest/utf8")" = t
201 if test "$(cat "$dotest/keep")" = t
205 if test "$(cat "$dotest/sign")" = t
207 SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
209 s/^/Signed-off-by: /'
215 last=`cat "$dotest/last"`
216 this=`cat "$dotest/next"`
219 this=`expr "$this" + 1`
223 if test "$this" -gt "$last"
230 while test "$this" -le "$last"
232 msgnum=`printf "%0${prec}d" $this`
233 next=`expr "$this" + 1`
234 test -f "$dotest/$msgnum" || {
240 # If we are not resuming, parse and extract the patch information
241 # into separate files:
242 # - info records the authorship and title
243 # - msg is the rest of commit log message
244 # - patch is the patch body.
246 # When we are resuming, these files are either already prepared
247 # by the user, or the user can tell us to do so by --resolved flag.
250 git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
251 <"$dotest/$msgnum" >"$dotest/info" ||
253 git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
257 GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
258 GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
259 GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
261 if test -z "$GIT_AUTHOR_EMAIL"
263 echo "Patch does not have a valid e-mail address."
267 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
269 SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
270 case "$keep_subject" in -k) SUBJECT="[PATCH] $SUBJECT" ;; esac
274 if test '' != "$SIGNOFF"
277 sed -ne '/^Signed-off-by: /p' \
278 "$dotest/msg-clean" |
282 test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
283 test '' = "$LAST_SIGNED_OFF_BY" && echo
291 if test -s "$dotest/msg-clean"
294 cat "$dotest/msg-clean"
296 if test '' != "$ADD_SIGNOFF"
300 } >"$dotest/final-commit"
303 case "$resolved$interactive" in
305 # This is used only for interactive view option.
306 git-diff-index -p --cached HEAD >"$dotest/patch"
312 if test "$interactive" = t
315 die "cannot be interactive without stdin connected to a terminal."
317 while test "$action" = again
319 echo "Commit Body is:"
320 echo "--------------------------"
321 cat "$dotest/final-commit"
322 echo "--------------------------"
323 printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
327 [aA]*) action=yes interactive= ;;
328 [nN]*) action=skip ;;
329 [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
332 LESS=-S ${PAGER:-less} "$dotest/patch" ;;
340 if test $action = skip
346 if test -x "$GIT_DIR"/hooks/applypatch-msg
348 "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
353 echo "Applying '$SUBJECT'"
358 git-apply $binary --index "$dotest/patch"
362 # Resolved means the user did all the hard work, and
363 # we do not have to do any patch application. Just
364 # trust what the user has in the index file and the
367 changed="$(git-diff-index --cached --name-only HEAD)"
368 if test '' = "$changed"
370 echo "No changes - did you forget update-index?"
377 if test $apply_status = 1 && test "$threeway" = t
381 # Applying the patch to an earlier tree and merging the
382 # result may have produced the same tree as ours.
383 changed="$(git-diff-index --cached --name-only HEAD)"
384 if test '' = "$changed"
386 echo No changes -- Patch already applied.
390 # clear apply_status -- we have successfully merged.
394 if test $apply_status != 0
396 echo Patch failed at $msgnum.
400 if test -x "$GIT_DIR"/hooks/pre-applypatch
402 "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
405 tree=$(git-write-tree) &&
406 echo Wrote tree $tree &&
407 parent=$(git-rev-parse --verify HEAD) &&
408 commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
409 echo Committed: $commit &&
410 git-update-ref HEAD $commit $parent ||
413 if test -x "$GIT_DIR"/hooks/post-applypatch
415 "$GIT_DIR"/hooks/post-applypatch